cc.Class({
    extends: cc.Component,
    properties: {
        _isShow: false,
        showTime: 1.0,
        tipPrefab:cc.Prefab
    },

    // use this for initialization
    onLoad: function () {
        // gd.global.tipInfo = this;
        this.node.active = this._isShow;
        // uiManager.uiRootMap[uiManager.UIID.MSGTIP] = this;

        // this.newPool(this.tipPrefab,1);

        this.waitMsgList = [];
    },

    showMsg: function () {


        var e = arguments[0];

        var _msgData = gd.gameCtrl.getMsgCodeConfigs();
        var i = _msgData[e];

        cc.log("ShowMsg", e);

        if (i) {
            for (var n = [], a = 1; a < arguments.length; a++) n[a - 1] = arguments[a];
            var s = this.translate(i);
            var ss = cc.js.formatStr(s.text, n);
            this.show(ss)
        } else {
            this.show(e);
        }

    },

    open(content){
        this.show(content);
    },

    showGetItems(objs) {
        if (!uiManager.getCanShowMsgTip()) return;
        var self = this;
        var items = objs.items;

        if (items) {
            for (var itemKey in items) {
                let itemValue = items[itemKey];
                let itemName = "";
                if (itemKey == gs.c_prop.spItemIdKey.gold) {
                    itemName = i18n.t("gold");
                } else if (itemKey == gs.c_prop.spItemIdKey.diamond) {
                    itemName = i18n.t("diamond");
                } else if (itemKey == gs.c_prop.spItemIdKey.energy) {
                    itemName = i18n.t("enegry");
                } else if (itemKey == gs.c_prop.spItemIdKey.exp) {
                    itemName = i18n.t("exp");
                } else {
                    var t_item = gd.itemCtrl.getItemConfig(itemKey);
                    if (t_item) {
                        itemName = t_item[gs.t_item_name];
                    }else {
                        itemName = "itemKey "+itemKey+"没有配置";
                    }
                }
                let showName = itemName + ":" + itemValue;
                self.show(showName);
            }
        }
    },

    translate: function (msgData) {
        return {
            text: msgData[gs.c_msgCode_text],
            type: msgData[gs.c_msgCode_region0],
            onTop: msgData[gs.c_msgCode_onTop],
            time: msgData[gs.c_msgCode_time]
        };
    },

    show: function (content) {
        var self = this;
        this._isShow = true;
        if (this.node) {
            this.node.active = this._isShow;
        }

        this.waitMsgList.push(content);

    },
    addMsg(content){
        var showNode = this.getPool(this.tipPrefab.name);
        showNode.stopAllActions();
        showNode.y = this.tipPrefab.data.y;
        showNode.active = true;

        this.setNodeConent(content, showNode);

        showNode.parent = this.node;
    },
    setNodeConent: function (content, node) {

        var contentLabel = node.getChildByName('content').getComponent(cc.RichText);
        contentLabel.string = content || 0;
    },
    onDestory: function () {
        if (gd.global) {
            gd.global.tipInfo = null;
        }
    },
    moveUp:function(delY){
        let index = 0;
        while(index<this.node.children.length){
            let obj = this.node.children[index];
            obj.y += delY;
            if(obj.y > 120){
                obj.putPool();
            }else{
                index++;
            }
        }
    },
    update:function(dt){
        let waitLength = this.waitMsgList.length;
        let timeScale = waitLength>0?waitLength:1;
        this.moveUp(dt*120 * timeScale);
        let childLength = this.node.children.length;
        if(waitLength > 0){
            let newFlag = false;
            if(childLength == 0){
                newFlag = true;
            }else if(childLength < 3){
                let lastNode = this.node.children[childLength-1];
                if(lastNode.y >= 60){
                    newFlag = true;
                }
            }
            if(newFlag){
                let msg = this.waitMsgList.shift();
                this.addMsg(msg);
            }
        }
        if(waitLength == 0 && childLength ==0){
            this.node.active = false;
        }
    },
});
